	PROGRAM MAIN

c		WARNINGS:
c	LUN numbers used: 1,2,3,57

c	11_19.06 - change to Brewer geometry and wavelengths
c	07_20.06 - change to LIDORTV3

	double precision sza,cloud_ssa
        parameter (cloud_ssa=0.99999)
	character csza*2
        parameter (sza=45.0D+00,csza='45')
        double precision salbedo,cld_toa	! at salbedo and pscale(1)=1.0
        parameter (salbedo=0.05)
	character csp*4
 	parameter (csp='so2.')
c	parameter (csp='ozn.')
c	parameter (csp='no2.')

	integer nprs, ilam
        parameter (nprs=2)	! number of Pressure levels in Rayleigh atmosphere to calculate Ia(nprs), Sb(nprs) and T(nprs)
				! or single pressure level for wf calculation (call wf(..)
                            	! This is done by scaling tau_ray                                                           
        double precision pscale(nprs)
        data pscale/1.0,0.6/	!  Pg=1 [atm],   Pc=0.6 [atm]
        double precision asym,tcl
        parameter (asym=0.859)	! asymetry parameter for C1 cloud [Deirmendjian 1969], r_max=15um
        character*4 stcloud
        parameter (stcloud='tc00')	! cloud optical thickness

        open(1,file='Layers_'//csp//stcloud,status='old')	! Input layers file should include all 9 wavelengths

 	do ilam=1,12		! Wavelength cycle: 296,..,340

c	WF calculation for Ps(nprs)                   
 	call wf(cloud_ssa,csp,sza,salbedo,1,pscale,		! input parameters: salbedo=0.05, nprs=1, pscale(1)=1.0
     &                 cld_toa,tcl)		! output parameters: cld_toa, plus wf_tcl01 - weighting function


	enddo			! End :  wavelength cycle

         close(1)		! close input layer file
	 close(57)		! close output results file

        call system('mv fort.57 wfcld45_tc00_a05_o3')

	stop
	end
	subroutine wf(cloud_ssa,csp,sza,salbedo,nprs,pscale,isave,tcl_tot)

        integer IB,UM,UA,V
        double precision cloud_ssa,salbedo
	character*4 csp

C  include file of dimensions and numbers

        INCLUDE '../includes/LIDORT.PARS'

C  input variables


        INCLUDE '../includes/LIDORT_INPUTS.VARS'
        INCLUDE '../includes/LIDORT_L_INPUTS.VARS'

C  include file of bookkeeping variables

        INCLUDE '../includes/LIDORT_BOOKKEEP.VARS'

C  result variables

        INCLUDE '../includes/LIDORT_RESULTS.VARS'
        INCLUDE '../includes/LIDORT_L_RESULTS.VARS'

C  help variables

        INTEGER          STATUS_INPUTCHECK,status_inputread
        INTEGER          STATUS_CALCULATION

	integer  iprs,nprs,nair
        integer          n, ndum, idum, l, nmom,k
	double precision sza,wvlth,psrfc,xno2,tautot
        double precision tray_tot,tno2_tot,tcl_tot,taer_tot
        double precision dum, tot_tau, gas_tau, aer_tau, ray_tau
        double precision cld_tau, depol, ray_2mom, tau_scat, amom(500)
        double precision cld_tau_scat,aer_tau_scat                       
        double precision gastau_save(MAXLAYERS),tottau_save(MAXLAYERS)
        double precision pres_save(MAXLAYERS),tauscat_save(MAXLAYERS)
        double precision epsilon

c       Cloud pressure levels for LER calculation

        double precision pscale(nprs)
        double precision isave

C  Read the LIDORT inputs from file

        CALL LIDORT_L_INPUT_MASTER
     &   ( 'wf.inp','LIDORT_wf_LOGFILE',status_inputread)
        if ( status_inputread.ne.lidort_success)stop'badread wf.inp'     


C  Note: NMOMENTS_INPUT should be very large for SS corrections, and must
C        at least 2*NSTREAMS - 1 (delta-M off), 2*NSTREAMS (delta-M on)
                
        
c        SUN0 = sza              ! re-define  solar zenith angle in degrees (ignore wf.inp value)
        BEAM_SZAS(1) = sza




C  Direct nadir output - settings
c        DO_NO_AZIMUTH         = .TRUE.
c        N_USER_STREAMS = 1
c        USER_ANGLES_INPUT(1) = 0.0
c        N_USER_RELAZMS = 1
c       USER_RELAZMS(1) = 0.0              ! Dummy

C  Cycle loop
C  ==========

	do iprs=nprs,nprs		!  cycle through surf. pressure (scaling tau_ray in each layer)
c	do iprs=1,nprs		!  cycle through surf. pressure (scaling tau_ray in each layer)


C  Set up optical properties and their derivatives

C  read cloud moments

        open(2,file='C1_pmom_lesha',status='old')
        read(2,*)nmom
        do n = 0, nmom - 1
          read(2,*) ndum, amom(n+1)
        enddo
        close(2)

C  read cloud atmosphere

        HEIGHT_GRID(0)   = 85.0D0       ! heights in [km] descending from TOA

        read(1,*)
	read(1,*) wvlth,psrfc,depol,xno2,tautot,dum,nlayers
	write(6,*) wvlth,psrfc,depol,xno2,tautot,dum,nlayers
        WRITE(57,*) 'wvlth psrfc  rho  xNO2[atmcm] tautot deltau nolyr'
	WRITE(57,*) wvlth,pscale(iprs)*psrfc,depol,xno2,tautot,dum,
     &                                                     nlayers
        ray_2mom = ( one - depol ) / ( two + depol )
        read(1,*)
        read(1,*)tray_tot,taer_tot,tno2_tot,tcl_tot,dum,dum,idum
        WRITE(57,*) 'tray   taer   tno2   tcl_tot  '
        WRITE(57,*)pscale(iprs)*tray_tot,taer_tot,tno2_tot,tcl_tot
        read(1,*)
        read(1,*)dum,dum
        read(1,*)

        do n = 1, nlayers
          read(1,*)idum,HEIGHT_GRID(n),dum,
     &           ray_tau, aer_tau, gas_tau, cld_tau, tot_tau
        pres_save(n)=pscale(iprs)*dum
c         tot_tau=tot_tau - ray_tau*(1.-pscale(iprs) )      	! correct tot_tau first using unchanged ray_tau
          ray_tau=pscale(iprs)*ray_tau         			! Scale Rayleigh tau according to surface pressure level
          tot_tau = ray_tau + aer_tau + gas_tau + cld_tau
          deltau_vert_input(n) =  tot_tau			! Layer tau

c						tau_scat
          cld_tau_scat=cld_tau*cloud_ssa
          aer_tau_scat=aer_tau*cloud_ssa
          tau_scat = ray_tau + aer_tau_scat + cld_tau_scat

          omega_total_input(n) = tau_scat / tot_tau		!  Layer SSA
c         if ( omega_total_input(n) .gt. 0.99999999d0 ) then
c           omega_total_input(n) = 0.99999999d0
c         endif

          gastau_save(n)  = gas_tau
          tottau_save(n)  = tot_tau
          tauscat_save(n) = tau_scat

c						Phase function
          phasmoms_total_input(0,n) = one
          phasmoms_total_input(1,n) = cld_tau_scat * amom(2)/tau_scat
          phasmoms_total_input(2,n) = 
     &    (ray_tau*ray_2mom + cld_tau_scat*amom(3) ) / tau_scat
          do l = 3, nmoments_input
            phasmoms_total_input(l,n)=cld_tau_scat*amom(l+1)/tau_scat
          enddo
c						Layer WF vrt gas_tau
          layer_vary_flag(n)   = .true.
          layer_vary_number(n) = 1
          l_omega_total_input(1,n) = - gas_tau / tot_tau
          l_deltau_vert_input(1,n) = + gas_tau / tot_tau
          do l = 0, nmoments_input
           l_phasmoms_total_input(1,l,n) = zero
          enddo
        enddo		! layer (n)  cycle
c       close(1)		!  close input layer program in the main program


c       RE-SET AIRCRAFT LEVEL INDEX (re-set value in wf.inp )
        nair=0
        do while (HEIGHT_GRID(nair) .gt. 12.0 )
        nair=nair+1
        end do
        write(6,*) 'aircraft lbound index=',nair
        LBOUND_TAUS_INPUT(1)=nair		! only one user level is required

C  prepare surface (Lambertian albedo)

        Lambertian_ALBEDO = salbedo

C  call LIDORT with WF

        write(*,'(a)')   ' starting LIDORT_L_MASTER '
        CALL LIDORT_L_MASTER
     &        ( STATUS_INPUTCHECK, STATUS_CALCULATION )
        CALL LIDORT_STATUS
     &        ( STATUS_INPUTCHECK, STATUS_CALCULATION )

        isave = INTENSITY(1,1,UPIDX)



C  output

      IF ( STATUS_CALCULATION .NE. LIDORT_SUCCESS .OR.
     &     STATUS_INPUTCHECK  .EQ. LIDORT_SERIOUS ) THEN
       WRITE(*,*)' No output written to file'
      ELSE
       WRITE(*,*)' output written to file TEST3_RADIANCES.out'
       OPEN(3,FILE='TEST3_RADIANCES.out',STATUS='unknown')
       write(3,'(/a/a//a/)')'Upwelling TOA radiances:',
     &           '------------------------',
     &           'solar angle  view angle   Azimuth      Intensity'
       DO IB = 1, NBEAMS
        DO UM = 1, N_USER_STREAMS
         DO UA = 1, N_USER_RELAZMS
          V = UMOFF(IB,UM) + UA
          write(3,'(1x,f7.2,5x,f7.2,5x,f8.2,2x,1pe16.8)')
     & BEAM_SZAS(IB),USER_ANGLES_INPUT(UM),USER_RELAZMS(UA),
     &  INTENSITY(1,V,UPIDX)
         ENDDO
        ENDDO
       ENDDO
       write(3,'(/a/a//a/)')'Upwelling BOA radiances:',
     &           '------------------------',
     &           'solar angle  view angle   Azimuth      Intensity'
       DO IB = 1, NBEAMS
        DO UM = 1, N_USER_STREAMS
         DO UA = 1, N_USER_RELAZMS
          V = UMOFF(IB,UM) + UA
          write(3,'(1x,f7.2,5x,f7.2,5x,f8.2,2x,1pe16.8)')
     & BEAM_SZAS(IB),USER_ANGLES_INPUT(UM),USER_RELAZMS(UA),
     &  INTENSITY(2,V,DNIDX)
         ENDDO
        ENDDO
       ENDDO
       CLOSE(3)
      ENDIF

C  finish

          WRITE(57,*        )
     & 	'SZA=',sza                      
          WRITE(57,*        )
     & 	'Surface presure=',pscale(iprs)*psrfc
          WRITE(57,*        )
     & 	'FLUX_FACTOR=',FLUX_FACTOR       
          WRITE(57,*        )
     & 	'Surface albedo=',LAMBERTIAN_ALBEDO,
     & 'aircraft upwelling radiance (isave=INTENSITY(1,1,UPIDX)',isave


C  call FD LIDORT repeats

        DO_SIMULATION_ONLY      = .TRUE.
        DO_LINEARIZATION        = .FALSE.
        DO_ATMOS_LINEARIZATION  = .FALSE.

        epsilon = 0.01d0	! this works only for tcl=0 and 1
c       epsilon = 0.001d0	! this works only for tcl=0 and 1

        do k = 1, nlayers
         write(*,*)'doing pert ',k
         do n = 1, nlayers
          if ( k.eq.n ) then
            gas_tau = gastau_save(n) * (1.0d0 + epsilon)
            tot_tau = tottau_save(n) + gastau_save(n) * epsilon
          else
            gas_tau = gastau_save(n)
            tot_tau = tottau_save(n)
          endif
c          write(*,*)k,n,tauscat_save(n),tottau_save(n)

          deltau_vert_input(n) =  tot_tau
          omega_total_input(n) = tauscat_save(n) / tot_tau
c         if ( omega_total_input(n) .gt. 0.99999999d0 ) then
c           omega_total_input(n) = 0.99999999d0
c         endif
          layer_vary_flag(n)   = .false.
          layer_vary_number(n) = 0
          l_omega_total_input(1,n) = zero
          l_deltau_vert_input(1,n) = zero
          do l = 0, nmoments_input
            l_phasmoms_total_input(1,l,n) = zero
          enddo
         enddo

          CALL LIDORT_L_MASTER
     &        ( STATUS_INPUTCHECK, STATUS_CALCULATION )
          CALL LIDORT_STATUS
     &        ( STATUS_INPUTCHECK, STATUS_CALCULATION )

          WRITE(57,'(1p12e14.5)')
     &   half*(HEIGHT_GRID(k)+HEIGHT_GRID(k-1)),pres_save(k),
     &   gastau_save(k),INTENSITY(1,1,UPIDX),
     &  (INTENSITY(1,1,UPIDX)-isave)/EPSILON,
     &   ATMOSWF(1,K,1,1,UPIDX),
     &  (INTENSITY(1,1,UPIDX)-isave)/EPSILON/gastau_save(k)/
     &                                                  isave,
     &   ATMOSWF(1,K,1,1,UPIDX)/isave/gastau_save(k)

        enddo


C  Finish

	enddo	! end of pressure cycle

	return
        END

