name='o3_amf_aircraft'     

mode='print'
;mode='screen'
xmin= 0.0 & xmax=6.0  & ymin=0 & ymax=40.0 &  yleg=25.0	 & dyleg=3.5 & dyleg1=2.0

;	O3 AMF

;		440nm and NADIR   only
h_bot=3. & h_top=4.13
if mode eq 'screen' then begin
set_plot,'X' & device,pseudo_color=8
endif else begin
set_plot,'PS' & device,/landscape,/color,filename=name+'.ps'
endelse

;               Blue                    Red
;        0  1   2   3   4   5  6    7   8   9   10  11  12  13  14
;       -30 -25 -20 -15 -10 -5      0  +5  +10 +15 +20 +25 +30 +35
rr = [255,000,000,000,000,100,150,000,255,255,255,255,200,150,000]
gg = [255,000,050,100,150,200,220,240,230,150,100,060,020,000,000]
bb = [255,150,240,255,255,255,255,000,230,150,100,060,020,000,000]

!p.background=0
tvlct,rr,gg,bb

!x.thick=4 & !y.thick=4
!p.thick=6
!p.charthick=1
;!p.charthick=6
!p.charsize=1.5


path='/omi/home/krotkov/LIDORTV3/aircraft/'	; L3  NO2 WF results
;path='/omi/home/krotkov/LIDORTV3/Brewer/'	; L3  NO2 WF results
;path='/omi/home/krotkov/LIDORTV23/cloud_amf/'	; L23  NO2 WF results

;		LIDORT23 analytical results
get_wfcld,path,'wfcld46_tc00_a05_o3_10up',mlr,sza,hg,pg,amf_g,amf_fd,fc_g,ref_g,tau,w & cref_g=string(ref_g,format='(f6.3)') & cfc_g=string(fc_g,format='(f5.2)') &  cw=string(w,format='(f5.1)') & cler_g=' 0.05' 
g=dblarr(mlr+1) & g(0)=85.	 &  dth_g=dblarr(mlr) & dth_ge=dth_g
for i=0,mlr-1 do begin
g(i+1) = 2.*hg(i) - g(i)	; calculate heights at bottom of layers (hc is middle layer heihts)
dth_g(i)=tau(i)/(g(i) - g(i+1))
dth_ge(i)=2.0*exp(-1./1.*g(i))
endfor
;		Write local amf: Rayleigh Ps
close,2 & openw,2,name+'.txt'
printf,2,'Wavelength= '+cw                                             
printf,2,'Rayleigh plus O3 prof'               
printf,2,'NADIR,	SZA=',sza 
printf,2,'Surface albedo=0.05; Surface Pressure=1atm'
printf,2,'TOA REflectance=',ref_g
printf,2
printf,2,'Local AMF: d(lnI)/d(tau_oz)  LIDORT calculation' 
printf,2,'Mid-layer 		No scattering limit=1+sec(SZA)=2.4396'
printf,2,'	N  height [km]	Pressure	tau_no2		AMF(an)      AMF(fd)     ' 
for i=0,mlr-1  do printf,2,i+1,hg(i),pg(i),tau(i),amf_g(i),amf_fd(i)                
close,2

plot,amf_g,hg,/nodata,color=14,$
title='Local AMF  		O!d3!n at  !4k!x= '+cw,$
xr=[xmin,xmax],/xs,xtitle='Local AMF: d(lnI)/d(!4s!x!dO3!n) ',$
yr=[ymin,ymax],/ys,ytitle='Height, km'

!p.color=14
plots,[xmin,xmax],[hg(21),hg(21)],thick=0.5
xyouts,2,hg(20),'Aircraft altitude'

xyouts,3.2,35,'Ozone AMF',charsize=1.5
xyouts,3.2,30,'!4h!x!do!n=45!uo!n' &  xyouts,3.7,30,'albedo=0.05'

l=findgen(3)*0.15 + 0.2
xyouts,1.60,29,'sec(!4h!x!do!n)',orientation=90.0,charsize=1.6,charthick=4.0 &  plots,[1.41421,1.41421],[0,ymax],line=0,thick=0.5	; upwelling path SZA=45, zenith

;oplot,                 amf_an         ,h, line=1  ; FD Local AMF  =     dlnI/d(tau_oz)
;xyouts,1.2,yleg,'  R'   ;& xyouts,1.8,yleg,' F!dc' ;& xyouts,3.0,yleg,' Trop AMF'  


;		12km, nadir
get_wfcld,path,'wfcld46_tc00_a05_o3_12up_nadir90',mlr,sza,hg,pg,amf_g,amf_fd,fc_g,ref_g,tau,w &cref_g=string(ref_g,format='(f6.3)') & cfc_g=string(fc_g,format='(f5.2)') &  cw=string(w,format='(f5.1)') & cler_g=' 0.05' 
!p.color=2 & oplot,amf_g,hg, line=0  & yleg=yleg-dyleg1   &  oplot,l+3,l/l*yleg,line=2 & xyouts,0.6+3,yleg,'nadir'  ;&   xyouts,1.2,yleg,cler_g & xyouts,1.8,yleg,cfc_g ; &  xyouts,3.0,yleg,cref_g


;		10km, view=70 deg
get_wfcld,path,'wfcld46_tc00_a05_o3_12up_v75_p90',mlr,sza,hg,pg,amf_g,amf_fd,fc_g,ref_g,tau,w &cref_g=string(ref_g,format='(f6.3)') & cfc_g=string(fc_g,format='(f5.2)') &  cw=string(w,format='(f5.1)') & cler_g=' 0.05' 
!p.color=11 & oplot,amf_g,hg, line=2  & yleg=yleg-dyleg1   &  oplot,l+3,l/l*yleg,line=2 & xyouts,0.6+3,yleg,'view=75!uo!n !4u!x=90!uo!n'  ;&   xyouts,1.2,yleg,cler_g & xyouts,1.8,yleg,cfc_g ; &  xyouts,3.0,yleg,cref_g




if mode ne 'screen' then device,/close

stop
end
