name='o3amf_s46_toa_tc00'     

mode='print'
mode='screen'
xmin= 0.0 & xmax=4.0  & ymin=0 & ymax=40.0 &  yleg=30.0	 & dyleg=3.5 & dyleg1=2.0

;	O3 AMF

;		440nm and NADIR   only
h_bot=3. & h_top=4.13
if mode eq 'screen' then begin
set_plot,'X' & device,pseudo_color=8
endif else begin
set_plot,'PS' & device,/landscape,/color,filename=name+'.ps'
endelse

;               Blue                    Red
;        0  1   2   3   4   5  6    7   8   9   10  11  12  13  14
;       -30 -25 -20 -15 -10 -5      0  +5  +10 +15 +20 +25 +30 +35
rr = [255,000,000,000,000,100,150,000,255,255,255,255,200,150,000]
gg = [255,000,050,100,150,200,220,240,230,150,100,060,020,000,000]
bb = [255,150,240,255,255,255,255,000,230,150,100,060,020,000,000]

!p.background=0
tvlct,rr,gg,bb

!x.thick=4 & !y.thick=4
!p.thick=6
!p.charthick=6
!p.charsize=1.5


path='/omi/home/krotkov/LIDORTV3/Brewer/'	; L3  NO2 WF results
;path='/omi/home/krotkov/LIDORTV23/cloud_amf/'	; L23  NO2 WF results

;		LIDORT23 analytical results
get_wfcld,path,'wfcld46_tc00_a05_o3_02dn',mlr,sza,hg,pg,amf_g,amf_fd,fc_g,ref_g,tau,w & cref_g=string(ref_g,format='(f6.3)') & cfc_g=string(fc_g,format='(f5.2)') &  cw=string(w,format='(f5.1)') & cler_g=' 0.05' 
g=dblarr(mlr+1) & g(0)=85.	 &  dth_g=dblarr(mlr) & dth_ge=dth_g
for i=0,mlr-1 do begin
g(i+1) = 2.*hg(i) - g(i)	; calculate heights at bottom of layers (hc is middle layer heihts)
dth_g(i)=tau(i)/(g(i) - g(i+1))
dth_ge(i)=2.0*exp(-1./1.*g(i))
endfor
;		Write local amf: Rayleigh Ps
close,2 & openw,2,name+'.txt'
printf,2,'Wavelength= '+cw                                             
printf,2,'Rayleigh plus O3 prof'               
printf,2,'NADIR,	SZA=',sza 
printf,2,'Surface albedo=0.05; Surface Pressure=1atm'
printf,2,'TOA REflectance=',ref_g
printf,2
printf,2,'Local AMF: d(lnI)/d(tau_oz)  LIDORT calculation' 
printf,2,'Mid-layer 		No scattering limit=1+sec(SZA)=2.4396'
printf,2,'	N  height [km]	Pressure	tau_no2		AMF(an)      AMF(fd)     ' 
for i=0,mlr-1  do printf,2,i+1,hg(i),pg(i),tau(i),amf_g(i),amf_fd(i)                
close,2

plot,amf_g,hg,/nodata,color=14,$
title='Local AMF  		O!d3!n at  !4k!x= '+cw,$
xr=[xmin,xmax],/xs,xtitle='Local AMF: d(lnI)/d(gas_tau) ',$
yr=[ymin,ymax],/ys,ytitle='Height, km'

!p.color=14
 ;plots,[xmin,xmax],[hg(14),hg(14)],thick=0.5

xyouts,0.2,35,'!4h!x!do!n=46!uo!n'
xyouts,0.9,35,'albedo=0.05'
xyouts,1.8,35,'NADIR'             
;plots,[xmin,xmax],[h_top,h_top],thick=0.5

l=findgen(3)*0.15 + 0.2
xyouts,2.60,29,'1 + sec(!4h!x!do!n)',orientation=90.0,charsize=1.6,charthick=4.0 &  plots,[2.43956,2.43956],[0,ymax],line=0,thick=0.5	; upwelling path SZA=46, nadir
xyouts,1.60,29,'sec(!4h!x!do!n)',orientation=90.0,charsize=1.6,charthick=4.0 &  plots,[1.43956,1.43956],[0,ymax],line=0,thick=0.5	; dnwelling path SZA=46, zenith

;oplot,                 amf_an         ,h, line=1  ; FD Local AMF  =     dlnI/d(tau_oz)
xyouts,1.2,yleg,'  R'   ;& xyouts,1.8,yleg,' F!dc' ;& xyouts,3.0,yleg,' Trop AMF'  

!p.color=11 & oplot,amf_g,hg, line=2  & yleg=yleg-dyleg1   &  oplot,l,l/l*yleg,line=2 & xyouts,0.6,yleg,'zenith'  ;&   xyouts,1.2,yleg,cler_g & xyouts,1.8,yleg,cfc_g ; &  xyouts,3.0,yleg,cref_g
;!p.color=14 & oplot,amf_fd,hg,psym=1  & yleg=yleg-dyleg1   &  oplot,l,l/l*yleg,psym=1 & xyouts,0.6,yleg,'Finite diff' ; &  xyouts,1.2,yleg,cler_g & xyouts,1.8,yleg,cfc_g ; &  xyouts,3.0,yleg,cref_g


get_wfcld,path,'wfcld46_tc00_a05_o3_02up',mlr,sza,hg,pg,amf_g,amf_fd,fc_g,ref_g,tau,w & cref_g=string(ref_g,format='(f6.3)') & cfc_g=string(fc_g,format='(f5.2)') &  cw=string(w,format='(f5.1)') & cler_g=' 0.05' 
!p.color=2 & oplot,amf_g,hg, line=2  & yleg=yleg-dyleg1   &  oplot,l,l/l*yleg,line=2 & xyouts,0.6,yleg,'nadir'  ;&   xyouts,1.2,yleg,cler_g & xyouts,1.8,yleg,cfc_g ; &  xyouts,3.0,yleg,cref_g

;		2km
get_wfcld,path,'wfcld46_tc00_a05_o3_2dn',mlr,sza,hg,pg,amf_g,amf_fd,fc_g,ref_g,tau,w & cref_g=string(ref_g,format='(f6.3)') & cfc_g=string(fc_g,format='(f5.2)') &  cw=string(w,format='(f5.1)') & cler_g=' 0.05' 
!p.color=11 & oplot,amf_g,hg, line=0  ;& yleg=yleg-dyleg1   &  oplot,l,l/l*yleg,line=2 & xyouts,0.6,yleg,'nadir'  ;&   xyouts,1.2,yleg,cler_g & xyouts,1.8,yleg,cfc_g ; &  xyouts,3.0,yleg,cref_g
get_wfcld,path,'wfcld46_tc00_a05_o3_2up',mlr,sza,hg,pg,amf_g,amf_fd,fc_g,ref_g,tau,w & cref_g=string(ref_g,format='(f6.3)') & cfc_g=string(fc_g,format='(f5.2)') &  cw=string(w,format='(f5.1)') & cler_g=' 0.05' 
!p.color=2 & oplot,amf_g,hg, line=0  ;& yleg=yleg-dyleg1   &  oplot,l,l/l*yleg,line=2 & xyouts,0.6,yleg,'nadir'  ;&   xyouts,1.2,yleg,cler_g & xyouts,1.8,yleg,cfc_g ; &  xyouts,3.0,yleg,cref_g


;		10km
get_wfcld,path,'wfcld46_tc00_a05_o3_10dn',mlr,sza,hg,pg,amf_g,amf_fd,fc_g,ref_g,tau,w &cref_g=string(ref_g,format='(f6.3)') & cfc_g=string(fc_g,format='(f5.2)') &  cw=string(w,format='(f5.1)') & cler_g=' 0.05' 
!p.color=11 & oplot,amf_g,hg, line=1  ;& yleg=yleg-dyleg1   &  oplot,l,l/l*yleg,line=2 & xyouts,0.6,yleg,'nadir'  ;&   xyouts,1.2,yleg,cler_g & xyouts,1.8,yleg,cfc_g ; &  xyouts,3.0,yleg,cref_g
get_wfcld,path,'wfcld46_tc00_a05_o3_10up',mlr,sza,hg,pg,amf_g,amf_fd,fc_g,ref_g,tau,w &cref_g=string(ref_g,format='(f6.3)') & cfc_g=string(fc_g,format='(f5.2)') &  cw=string(w,format='(f5.1)') & cler_g=' 0.05' 
!p.color=2 & oplot,amf_g,hg, line=1  ;& yleg=yleg-dyleg1   &  oplot,l,l/l*yleg,line=2 & xyouts,0.6,yleg,'nadir'  ;&   xyouts,1.2,yleg,cler_g & xyouts,1.8,yleg,cfc_g ; &  xyouts,3.0,yleg,cref_g

;		18km
get_wfcld,path,'wfcld46_tc00_a05_o3_18dn',mlr,sza,hg,pg,amf_g,amf_fd,fc_g,ref_g,tau,w &cref_g=string(ref_g,format='(f6.3)') & cfc_g=string(fc_g,format='(f5.2)') &  cw=string(w,format='(f5.1)') & cler_g=' 0.05' 
!p.color=11 & oplot,amf_g,hg, line=3  ;& yleg=yleg-dyleg1   &  oplot,l,l/l*yleg,line=2 & xyouts,0.6,yleg,'nadir'  ;&   xyouts,1.2,yleg,cler_g & xyouts,1.8,yleg,cfc_g ; &  xyouts,3.0,yleg,cref_g
get_wfcld,path,'wfcld46_tc00_a05_o3_18up',mlr,sza,hg,pg,amf_g,amf_fd,fc_g,ref_g,tau,w &cref_g=string(ref_g,format='(f6.3)') & cfc_g=string(fc_g,format='(f5.2)') &  cw=string(w,format='(f5.1)') & cler_g=' 0.05' 
!p.color=2 & oplot,amf_g,hg, line=3  ;& yleg=yleg-dyleg1   &  oplot,l,l/l*yleg,line=2 & xyouts,0.6,yleg,'nadir'  ;&   xyouts,1.2,yleg,cler_g & xyouts,1.8,yleg,cfc_g ; &  xyouts,3.0,yleg,cref_g


;		35km
get_wfcld,path,'wfcld46_tc00_a05_o3_35dn',mlr,sza,hg,pg,amf_g,amf_fd,fc_g,ref_g,tau,w &cref_g=string(ref_g,format='(f6.3)') & cfc_g=string(fc_g,format='(f5.2)') &  cw=string(w,format='(f5.1)') & cler_g=' 0.05' 
!p.color=11 & oplot,amf_g,hg, line=4  ;& yleg=yleg-dyleg1   &  oplot,l,l/l*yleg,line=2 & xyouts,0.6,yleg,'nadir'  ;&   xyouts,1.2,yleg,cler_g & xyouts,1.8,yleg,cfc_g ; &  xyouts,3.0,yleg,cref_g
get_wfcld,path,'wfcld46_tc00_a05_o3_35up',mlr,sza,hg,pg,amf_g,amf_fd,fc_g,ref_g,tau,w &cref_g=string(ref_g,format='(f6.3)') & cfc_g=string(fc_g,format='(f5.2)') &  cw=string(w,format='(f5.1)') & cler_g=' 0.05' 
!p.color=2 & oplot,amf_g,hg, line=4  ;& yleg=yleg-dyleg1   &  oplot,l,l/l*yleg,line=2 & xyouts,0.6,yleg,'nadir'  ;&   xyouts,1.2,yleg,cler_g & xyouts,1.8,yleg,cfc_g ; &  xyouts,3.0,yleg,cref_g


;cler_c06=' 0.80'  ;		Rayleigh at Ps=0.6 and Rs=0.8
;get_wfcld,path,'wfray46_tc00_a80_06atm_no2',52,sza,hg,pc06,amf_c06,fc_c06,ref_c06,tau & cfc_c06=string(fc_c06, format='(f5.2)') & cref_c06=string(ref_c06,format='(f6.3)')
;hc06=interpol(hg,pg,pc06) & nbot=n_elements(pc06)
;amf_c06_int=interpol(amf_c06,hc06,hg)
;under=where(pg gt pc06(nbot-1),count)
;amf_c06_int(under)=0.0
;oplot,amf_c06_int,hg, line=0  & yleg=yleg-dyleg1      &  oplot,l,l/l*yleg ,line=0 & xyouts,0.6,yleg,'Rayleigh'  & xyouts,1.2,yleg,cler_c06 & xyouts,1.8,yleg,cfc_c06 ;& xyouts,3.0,yleg,cref_c06


;			Mie cloud tcl=20
;plots,[xmin,xmax],[h_bot,h_bot],thick=0.5,color=14
;!p.color=2 &  get_wfcld,path,'wfcld46_tc20_a05_no2',60,sza,hc,pc,amf_cld,fc,ref,tau  & cfc=string(fc,format='(f5.2)') & cref=string(ref,format='(f6.3)') & cmler=string(0.8*fc + 0.05*(1-fc),format='(f5.2)')
;oplot,amf_cld,hc, line=0  & yleg=yleg-dyleg      &  oplot,l,l/l*yleg ,line=0 & xyouts,1.2,yleg,cmler & xyouts,0.6,yleg,'!4s!x!dcl!n=20'  & xyouts,1.2,yleg,cmler & xyouts,1.8,yleg,cfc & xyouts,3.0,yleg,cref

;g=dblarr(61) & g(0)=85.	 &  dth_c=dblarr(60)
;for i=0,59 do begin
;g(i+1) = 2.*hc(i) - g(i)	; calculate heights at bottom of layers (hc is middle layer heihts)
;dth_c(i)=tau(i)/(g(i) - g(i+1))
;endfor
;trop=where(hc le 10.,count)	;	Tropospheric AMF from 0 to 10 km
;amf_cld_trop= int_tabulated(hc(trop),amf_cld(trop)*dth_c(trop))/int_tabulated(hc(trop),dth_c(trop))  & camf_cld_trop=string(amf_cld_trop,format='(f6.3)') 
;print,'Tcl=20,  AMF(trop)=',amf_cld_trop
;
;oplot,amf_cld,hc, line=0  & yleg=yleg-dyleg      &  oplot,l,l/l*yleg ,line=0 & xyouts,1.2,yleg,cmler & xyouts,0.6,yleg,'!4s!x!dcl!n=20'  & xyouts,1.2,yleg,cmler & xyouts,1.8,yleg,cfc & xyouts,3.0,yleg,camf_cld_trop
;
;w=fc*ref_c06/ref
;amf_mler=amf_g*(1-w ) + amf_c06_int*w  &  cmler=string(0.8*fc + 0.05*(1-fc),format='(f5.2)') &  cref_mler=string(ref_c06*fc +ref_g*(1-fc),format='(f6.3)')
;
;trop=where(hg le 10.,count)	;	Tropospheric AMF from 0 to 10 km
;amf_cld_trop= int_tabulated(hg(trop),amf_mler(trop)*dth_g(trop))/int_tabulated(hg(trop),dth_g(trop)) & camf_cld_trop=string(amf_cld_trop,format='(f6.3)')
;print,'MLER,  AMF(trop)=',amf_cld_trop
;oplot,amf_mler,hg, psym=4  & yleg=yleg-dyleg1     &  oplot,l,l/l*yleg ,psym=4 & xyouts,0.6,yleg,'MLER' & xyouts,1.2,yleg,cmler & xyouts,1.8,yleg,cfc & xyouts,3.0,yleg,camf_cld_trop


;			Mie cloud tcl=5
;!p.color=7 &  get_wfcld,path,'wfcld46_tc05_a05_no2',60,sza,hc,pc,amf_cld,fc,ref,tau  & cfc=string(fc,format='(f5.2)') & cref=string(ref,format='(f6.3)') & cmler=string(0.8*fc + 0.05*(1-fc),format='(f5.2)')

;g=dblarr(61) & g(0)=85.	 &  dth_c=dblarr(60)
;for i=0,59 do begin
;g(i+1) = 2.*hc(i) - g(i)	; calculate heights at bottom of layers (hc is middle layer heihts)
;dth_c(i)=tau(i)/(g(i) - g(i+1))
;endfor
;trop=where(hc le 10.,count)	;	Tropospheric AMF from 0 to 10 km
;amf_cld_trop= int_tabulated(hc(trop),amf_cld(trop)*dth_c(trop))/int_tabulated(hc(trop),dth_c(trop))	& camf_cld_trop=string(amf_cld_trop,format='(f6.3)')
;print,'Tcl=5,  AMF(trop)=',amf_cld_trop
;oplot,amf_cld,hc, line=0  & yleg=yleg-dyleg      &  oplot,l,l/l*yleg ,line=0 & xyouts,1.2,yleg,cmler & xyouts,0.6,yleg,'!4s!x!dcl!n=5'  & xyouts,1.2,yleg,cmler & xyouts,1.8,yleg,cfc & xyouts,3.0,yleg,camf_cld_trop
;

;w=fc*ref_c06/ref		; MLER
;amf_mler=amf_g*(1-w) + amf_c06_int*w &  cmler=string(0.8*fc + 0.05*(1-fc),format='(f5.2)') &  cref_mler=string(ref_c06*fc +ref_g*(1-fc),format='(f6.3)')
;trop=where(hg le 10.,count)	;	Tropospheric AMF from 0 to 10 km
;amf_cld_trop= int_tabulated(hg(trop),amf_mler(trop)*dth_g(trop))/int_tabulated(hg(trop),dth_g(trop)) & camf_cld_trop=string(amf_cld_trop,format='(f6.3)')
;print,'MLER,  AMF(trop)=',amf_cld_trop
;oplot,amf_mler,hg, psym=4  & yleg=yleg-dyleg1     &  oplot,l,l/l*yleg ,psym=4 & xyouts,0.6,yleg,'MLER' & xyouts,1.2,yleg,cmler & xyouts,1.8,yleg,cfc & xyouts,3.0,yleg,camf_cld_trop
;

;			Mie cloud tcl=1
;!p.color=11 &  get_wfcld,path,'wfcld46_tc01_a05_no2',60,sza,hc,pc,amf_cld,fc,ref,tau  & cfc=string(fc,format='(f5.2)') & cref=string(ref,format='(f6.3)') & cmler=string(0.8*fc + 0.05*(1-fc),format='(f5.2)')

;g=dblarr(61) & g(0)=85.	 &  dth_c=dblarr(60)
;for i=0,59 do begin
;g(i+1) = 2.*hc(i) - g(i)	; calculate heights at bottom of layers (hc is middle layer heihts)
;dth_c(i)=tau(i)/(g(i) - g(i+1))
;endfor
;trop=where(hc le 10.,count)	;	Tropospheric AMF from 0 to 10 km
;amf_cld_trop= int_tabulated(hc(trop),amf_cld(trop)*dth_c(trop))/int_tabulated(hc(trop),dth_c(trop)) & camf_cld_trop=string(amf_cld_trop,format='(f6.3)')
;print,'Tcl=1,  AMF(trop)=',amf_cld_trop
;oplot,amf_cld,hc, line=0  & yleg=yleg-dyleg      &  oplot,l,l/l*yleg ,line=0 & xyouts,1.2,yleg,cmler & xyouts,0.6,yleg,'!4s!x!dcl!n=1'  & xyouts,1.2,yleg,cmler & xyouts,1.8,yleg,cfc & xyouts,3.0,yleg,camf_cld_trop
;
;w=fc*ref_c06/ref & amf_mler=amf_g*(1-w) + amf_c06_int*w &  cmler=string(0.8*fc + 0.05*(1-fc),format='(f5.2)') &  cref_mler=string(ref_c06*fc +ref_g*(1-fc),format='(f6.3)')

;trop=where(hg le 10.,count)	;	Tropospheric AMF from 0 to 10 km
;amf_cld_trop= int_tabulated(hg(trop),amf_mler(trop)*dth_g(trop))/int_tabulated(hg(trop),dth_g(trop)) & camf_cld_trop=string(amf_cld_trop,format='(f6.3)')
;print,'MLER,  AMF(trop)=',amf_cld_trop
;oplot,amf_mler,hg, psym=4  & yleg=yleg-dyleg1     &  oplot,l,l/l*yleg ,psym=4 & xyouts,0.6,yleg,'MLER' & xyouts,1.2,yleg,cmler & xyouts,1.8,yleg,cfc & xyouts,3.0,yleg,camf_cld_trop



;tmin=xmin+0.1 & tmax=2 & scale=(tmax-tmin)/(max(dth_c)-min(dth_c)) & print,'tau scale=',scale
;b=(max(dth_c)*tmin - min(dth_c)*tmax)/(max(dth_c)-min(dth_c)) 
;dth_scaled_c=scale*dth_c + b
;dth_scaled_g=scale*dth_g + b
;oplot,dth_scaled_c(trop),hc(trop),psym=-1,thick=1,color=14
;oplot,dth_scaled_g(trop),hg(trop),psym=-1,color=14
;oplot,dth_ge(trop),hg(trop),psym=1,color=14

;column_tau=total(tau) & print,'NO2 tau=',column_tau
;vcd = 1.1918E-04	; [atmcm]
;gno2=column_tau/vcd   ; [ atmcm-1]
;print,'G NO2 [atmcm-1]=',gno2







if mode ne 'screen' then device,/close

stop
end
